function [M_K_C,M_D_K,sum_zv,filtered_idx_v] = filtering_v(K,D, M_K_C,topic_v_d,M_D_K,sum_zv,train_visual,filtered_idx_v)


count_c = sum(M_K_C,1);

p_k_c = M_K_C./count_c;
     

Entropy = p_k_c.*log(p_k_c.^(-1));
Entropy(isnan(Entropy)) = 0;

Entropy = sum(Entropy,1);
[value, index] = sort(Entropy,'descend');

thresh1 = length(find(value>0.95*max(Entropy)));
thresh2 = 0.05*size(M_K_C,2);

thresh = min(thresh1, thresh2);

filtered_idx = index(1:thresh);

filtered_idx_v = cat(2,filtered_idx_v,filtered_idx);

sum_zv = sum_zv - sum(M_K_C(:,filtered_idx),2); 
M_K_C(:,filtered_idx) = 0;

for d = 1:D
    current_dv = train_visual{d};
    current_dv_one_hot = zeros(1,size(M_K_C,2));
    current_dv_one_hot(current_dv)=1; %%%% unique words
    filtered_idx_one_hot = zeros(1,size(M_K_C,2));
    filtered_idx_one_hot(filtered_idx)=1;
    temp = current_dv_one_hot.*filtered_idx_one_hot;    
    matching = find(temp==1);
    [position,~,~] = find( current_dv == matching);
    
    corresponding_topics = topic_v_d{d}(position);
    corresponding_topics = sort(corresponding_topics);
    un_co_t = unique(corresponding_topics);
    for t = 1:length(un_co_t)
        M_D_K(d,un_co_t(t)) = M_D_K(d,un_co_t(t)) - length(find(corresponding_topics==un_co_t(t)));
    end
   
    
end





end