function [per_t,per_v,per_all] = Cal_perplexity(D,M_D_K,N_D_K,M_K_C,N_K_T,train_visual,train_textual,alpha,filtered_idx_v, filtered_idx_t)
psi = findPsi(N_K_T);
theta = findTheta(M_D_K,alpha);
phi = findPhi(M_K_C);

log_per_textual = 0;
textual_words_length = 0;
log_per_visual = 0;
visual_words_length = 0;
for d = 1:D
    current_theta = theta(d,:);    
    current_textual_doc = train_textual{d}; 
    if(~isempty(filtered_idx_t))
        [pos,~] = find(filtered_idx_t==current_textual_doc);
        current_textual_doc(pos) = [];
    end
    current_psi = psi(:,current_textual_doc);
    temp = log(current_theta*current_psi);
%     temp(isinf(temp)) = 0;
    log_per_textual = log_per_textual -sum(temp);
    textual_words_length = textual_words_length +length(current_textual_doc);
    
    
    
    current_visual_doc = train_visual{d};
    if(~isempty(filtered_idx_v))
        [pos,~] = find(filtered_idx_v==current_visual_doc);
        current_visual_doc(pos) = [];
    end
    current_phi = phi(:,current_visual_doc); 
    temp = log(current_theta*current_phi);
%     temp(isinf(temp)) = 0;
    log_per_visual = log_per_visual -sum(temp);
    visual_words_length = visual_words_length +length(current_visual_doc);

end
per_t = exp(log_per_textual/textual_words_length);
per_v = exp(log_per_visual/visual_words_length);

per_all = per_t+per_v;








end