function [theta,phi, psi,per_t,per_v,filtered_idx_v,filtered_idx_t] = Train_LDA_dynamic(iter_max_train,train_visual,train_textual, K,C,T, alpha,beta,gamma)
D = length(train_visual); %%%% training document size
disp(['Training document size is ', num2str(D)]);

tic;
disp('start initial training process');
[M_D_K,N_D_K,M_K_C,N_K_T,sum_zv,sum_zt,len_dv,len_dt,topic_v_d,topic_t_d] = initTrain(D,train_visual,train_textual, K,C,T, alpha,beta,gamma);
toc;
disp('initialzation for training completed.');


disp('start inference process');
iter = 1;
iter_freq = 10;
differ_perplexity = 10^8;
thresh_diff_perplexity = 0.1;
per_all_last = differ_perplexity;
count=1;
filtered_idx_v = [];
filtered_idx_t = [];

while (iter <=iter_max_train)&&(differ_perplexity > thresh_diff_perplexity)
    disp(['iteration ',num2str(iter)]);
    tic;
    [M_D_K,N_D_K,M_K_C,N_K_T,sum_zv,sum_zt,topic_v_d,topic_t_d] = inference(filtered_idx_v, filtered_idx_t,D,K,M_D_K,N_D_K,M_K_C,N_K_T,sum_zv,sum_zt,len_dv,len_dt,train_visual,train_textual,topic_v_d,topic_t_d,alpha);
    if(mod(iter,iter_freq)==1)
        [per_t(count),per_v(count),per_all] = Cal_perplexity(D,M_D_K,N_D_K,M_K_C,N_K_T,train_visual,train_textual,alpha,filtered_idx_v, filtered_idx_t);
%         disp(['current textual words perplexity is ' num2str(per_t(count))]);
%         disp(['current visual words perplexity is ' num2str(per_v(count))]);
%     [M_K_C,M_D_K,sum_zv,filtered_idx_v] = filtering_v( K,D, M_K_C,topic_v_d,M_D_K,sum_zv,train_visual,filtered_idx_v);
%     [N_K_T,N_D_K,sum_zt,filtered_idx_t] = filtering_t( K,D, N_K_T,topic_t_d,N_D_K,sum_zt,train_textual,filtered_idx_v);
        if(count~=1)
            diff1 = per_t(count)-per_t(count-1);
            diff2 = per_v(count)-per_v(count-1);
            if((diff1<0.5) && (diff2<1))
                disp('filtering....');
                [M_K_C,M_D_K,sum_zv,filtered_idx_v] = filtering_v( K,D, M_K_C,topic_v_d,M_D_K,sum_zv,train_visual,filtered_idx_v);
                [N_K_T,N_D_K,sum_zt,filtered_idx_t] = filtering_t( K,D, N_K_T,topic_t_d,N_D_K,sum_zt,train_textual,filtered_idx_t);
%                 disp('filtering end......');
            end
        end
%         filtered_idx_t = [];
        count = count+1;
        differ_perplexity = abs(per_all_last-per_all);
        per_all_last = per_all;
    end
    toc;
    iter = iter+1;
end
disp('inference process completed.');

theta = findTheta(M_D_K,alpha);
phi = findPhi(M_K_C);
psi = findPsi(N_K_T);
end