function [M_D_K,N_D_K,M_K_C,N_K_T,sum_zv,sum_zt,topic_v_d,topic_t_d] = prediction(phi,psi,D,K,M_D_K,N_D_K,M_K_C,N_K_T,sum_zv,sum_zt,len_dv,len_dt,test_visual,test_textual,topic_v_d,topic_t_d,alpha,filtered_idx_v,filtered_idx_t)
for d = 1:D
    %%%% visual words
%     if(iter==2)
%         d
%     end
    current_dv = test_visual{d};
    for c = 1:len_dv(d)       
        current_word = current_dv(c);
        if(isempty(find(filtered_idx_v==current_word))&&(sum(M_K_C(:,current_word))~=0))
            current_z = topic_v_d{d}(c);

            M_D_K(d,current_z) = M_D_K(d,current_z) - 1;
            M_K_C(current_z,current_word) = M_K_C(current_z,current_word)-1;
            sum_zv(current_z) = sum_zv(current_z)-1;

            p_z = [];
            %%% update probability for each z and resample %%%
            for k = 1:K
                term1 = phi(k,current_word)/sum_zv(k);
                term2 = M_D_K(d,k)+alpha;
                if(M_D_K(d,k)>0)
                    term3 = ((M_D_K(d,k)+1)/M_D_K(d,k))^N_D_K(d,k);
                else
                    term3 = 1;
                end
                p_z(k) = term1*term2*term3;
            end
            p_z = p_z./sum(p_z);

            new_z = randsample(1:K,1,true,p_z);
            topic_v_d{d}(c) = new_z;
            M_D_K(d,new_z) = M_D_K(d,new_z) + 1;
            M_K_C(new_z,current_word) = M_K_C(new_z,current_word)+1;
            sum_zv(new_z) = sum_zv(new_z)+1;        
        end
    end
    
    %%%% textual words
    current_dt = test_textual{d};
    for t = 1:len_dt(d)
        current_word = current_dt(t);
        if(isempty(find(filtered_idx_t==current_word))&&(sum(N_K_T(:,current_word))~=0)&&(sum(M_D_K(d,:))~=0))
            current_z = topic_t_d{d}(t);

            N_D_K(d,current_z) = N_D_K(d,current_z)-1;
            N_K_T(current_z,current_word) = N_K_T(current_z,current_word)-1;
            sum_zt(current_z) = sum_zt(current_z)-1;

            p_z = [];
            for k = 1:K
                term1 = psi(k,current_word)/sum_zt(k);
                term2 = M_D_K(d,k)/len_dv(d);
                p_z(k) = term1*term2;            
            end
            p_z = p_z./sum(p_z);

            new_z = randsample(1:K,1,true,p_z);
            topic_t_d{d}(t) = new_z;
            N_D_K(d,new_z) = N_D_K(d,new_z) + 1;
            N_K_T(new_z,current_word) = N_K_T(new_z,current_word)+1;
            sum_zt(new_z) = sum_zt(new_z)+1; 
        end
    end

end