function[score,gold_rank,err_rate] = retrieval(test_textual, theta_test,psi_test,filtered_idx_t)
%%%% compute score
N = size(test_textual,2);
K = size(theta_test,2);



for q=1:N %%%textual
    current_test_textual = test_textual{q};
%     [pos,~] = find(filtered_idx_t==current_test_textual);
%     current_test_textual(pos) = [];
    for i = 1:N %%% img
        score(q,i) = computeScore(current_test_textual,theta_test(i,:),psi_test);        
    end
%     score(q,:) = score(1,:)/length(current_test_textual); 
  
end
% score=bsxfun(@rdivide, score, sum(score,2));

    function score = computeScore(query, theta,psi)        
        score = log(theta*psi(:,query));
        score(isinf(score))=0;        
        score = sum(score);        
    end


%%%% compute score ends
%%%% compute err_rate

[~,rank] = sort(score,2,'descend');
for q =1:N
    gold_rank(q) = find(rank(q,:)==q);
end

for i = 1:100
    err_rate(i) = errorRate(gold_rank,i/100,N);
end

    function err_rate = errorRate(gold_rank, percent, N)
        correct = 0;
        thresh = percent*N;
        for n = 1:length(gold_rank)
            if (gold_rank(n) < thresh)
                correct = correct+1;
            end
        end
        err_rate = 1-correct/N; 
        
    end

end